package main

import (
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"

	//"html"
	"io"
	"log"
	"math"
	"math/rand"
	"os"
	"path"
	"path/filepath"
	"regexp"
	"strconv"
	"strings"
	"time"

	"github.com/google/uuid"
	"golang.org/x/net/html"
)

func readMessages(conn *Conn) {
	defer func() {
		if r := recover(); r != nil {
			log.Println("异常:", r)
			hfmsg := make(map[string]string) //初始化回复数据 map
			hfmsg["main"] = "数据发生异常！"
			send(conn, hfmsg)
			readMessages(conn)
			//saveData() //保存数据
		} else {
			closeConnection(conn) //关闭连接
		}
	}()
	var dianjicmd = make(map[int]map[string]string)       //初始化点击对照
	suijishuyuan := rand.NewSource(time.Now().UnixNano()) // 创建一个新的基于时间的随机源
	suijishu := rand.New(suijishuyuan)                    // 使用该随机源创建一个新的随机数生成器
	var uid string = conn.Uid
	var wid string = conn.Wid
	var url, dir string
	// 循环读取消息
	for {
		_, msg, err := conn.ReadMessage() // 读取消息
		if err != nil {
			if !strings.Contains(err.Error(), "websocket: close") {
				log.Println("读取消息时出错,uid:", uid, "错误:", err)
			}
			return
		}
		//log.Println("收到消息,uid:", uid, "消息:", string(msg))
		var data Data                                              // 给传输来的数据定义一个结构体
		if err := json.Unmarshal([]byte(msg), &data); err != nil { // 反序列化成结构体
			log.Println("消息序列化时出错,uid:", uid, "错误:", err)
			data.Sid = ""
			data.Cid = 1
		}
		if data.Ping == "ping" {
			continue
		}
		hfmsg := make(map[string]string) //初始化回复数据 map
		var neirong string = ""          //初始化主要返回内容
		//后台交互逻辑
		if uid == "" {
			if data.N != "" && data.P != "" {
				if data.N == safeuser && data.P == safepass {
					var lssid string                     //初始化sid
					uuid := uuid.New()                   // 生成一个新的 UUID
					lssid = uuid.String()                //将uuid转为字符串
					hasher := md5.New()                  // 创建一个新的 MD5 哈希对象
					io.WriteString(hasher, lssid)        // 写入数据到哈希对象
					hashBytes := hasher.Sum(nil)         // 计算哈希并获取结果
					lssid = fmt.Sprintf("%x", hashBytes) // 将字节数组转换为十六进制字符串
					uid = lssid
					conn.Uid = uid
				} else {
					hfmsg["main"] = "账号或者密码错误！<br>请输入账户和密码：<br><input type='text' id='n'><br><input type='text' id='p'><br><input type='button' title='登录' value='登录' onclick=dl() required><br>"
					send(conn, hfmsg)
					continue
				}
			} else {
				hfmsg["main"] = "请输入账户和密码：<br><input type='text' id='n'><br><input type='text' id='p'><br><input type='button' title='登录' value='登录' onclick=dl() required><br>"
				send(conn, hfmsg)
				continue
			}
		}
		//上传图片
		if data.Up != "" && wid != "" {
			var imgtype string
			if data.Imgtp != "" {
				if data.Imgtp == "image/png" {
					imgtype = ".png"
				} else if data.Imgtp == "image/jpeg" {
					imgtype = ".jpg"
				} else if data.Imgtp == "image/gif" {
					imgtype = ".gif"
				} else if data.Imgtp == "image/bmp" {
					imgtype = ".bmp"
				} else if data.Imgtp == "image/webp" {
					imgtype = ".webp"
				} else if data.Imgtp == "image/tiff" {
					imgtype = ".tiff"
				}
			}
			if imgtype != "" {
				binaryData, err := base64.StdEncoding.DecodeString(data.Ab)
				if err != nil {
					binaryData = []byte{}
				}
				vid3 := time.Now().Format("20060102150405")                   //获取时间YmdHis作为文件名称
				filename := "/static/" + dir + "/up/images/" + vid3 + imgtype // 定义要写入的文件名
				if savefile(filename, binaryData) {
					hfmsg["error"] = "0"
					hfmsg["imgurl"] = filename
				}
			} else {
				hfmsg["error"] = "1"
				hfmsg["imgurl"] = ""
			}
			send(conn, hfmsg)
			continue
		}
		//上传多张图片
		if data.Ups != "" && wid != "" {
			fileList := []string{}
			if len(data.Imgs) > 0 {
				lsname := time.Now().Format("20060102150405") //获取时间YmdHis作为文件名称
				i := 0
				for _, v := range data.Imgs {
					var imgtype string
					if v["tp"] == "image/png" {
						imgtype = ".png"
					} else if v["tp"] == "image/jpeg" {
						imgtype = ".jpg"
					} else if v["tp"] == "image/gif" {
						imgtype = ".gif"
					} else if v["tp"] == "image/bmp" {
						imgtype = ".bmp"
					} else if v["tp"] == "image/tiff" {
						imgtype = ".tiff"
					}
					if imgtype != "" {
						binaryData, err := base64.StdEncoding.DecodeString(v["ab"])
						if err != nil {
							binaryData = []byte{}
						}
						i++
						filename := "/static/" + dir + "/up/images/" + lsname + "_" + strconv.Itoa(i) + imgtype // 定义要写入的文件名
						if savefile(filename, binaryData) {
							fileList = append(fileList, filename)
						}
					}
				}
			}
			lsnr := strings.Join(fileList, ">") //转字符串
			if lsnr != "" {
				hfmsg["lookimgs"] = "1"
				hfmsg["imgurls"] = lsnr
			} else {
				hfmsg["lookimgs"] = "0"
			}
			send(conn, hfmsg)
			continue
		}
		//图片空间
		if data.Lookimg != "" && wid != "" {
			dir_str := data.Lookimg
			yema := 1
			if data.Yema > 1 {
				yema = data.Yema
			}
			fs, _ := listFiles("./static/" + dir + "/up/images" + dir_str)
			imgType := []string{".gif", ".png", ".jpg", ".jpeg", ".bmp", ".tiff"}
			fileList := []string{}
			if len(fs) > 0 {
				for _, v := range fs {
					if existsInSlice(imgType, filepath.Ext(v)) {
						fileList = append(fileList, "/"+strings.ReplaceAll(v, `\`, `/`))
					}
				}
			}
			zsl := len(fileList)
			if zsl > 0 {
				lsyema := ""
				if yema > 1 {
					ls := yema - 1
					lsyema += "<a onclick=lookimg('" + dir_str + "'," + strconv.Itoa(ls) + ")>上页</a> "
				}
				if float64(zsl)/20.0 > float64(yema) {
					ls := yema + 1
					lsyema += "<a onclick=lookimg('" + dir_str + "'," + strconv.Itoa(ls) + ")>下页</a> "
				}
				ksid := (yema - 1) * 20
				jsid := ksid + 20
				if ksid > zsl {
					ksid = 0
				}
				if jsid > zsl {
					jsid = zsl
				}
				fs = fileList[ksid:jsid]
				imgsl := len(fs)
				lsnr := strings.Join(fs, ">") //转字符串
				if lsnr != "" {
					hfmsg["lookimg"] = strconv.Itoa(imgsl)
					hfmsg["imgurls"] = lsnr
				} else {
					hfmsg["lookimg"] = "0"
				}
			}
			send(conn, hfmsg)
			continue
		}
		var cid = data.Cid                 //获取点击数
		var shuju = data.Shuju             //获取数据
		var cmds = make(map[string]string) //初始化当前点击对照
		//历遍点击对照表，获取当前点击对照
		for k, v := range dianjicmd[cid] {
			cmds[k] = v
		}
		var cmd = cmds["cmd"]

		//保持cid在一个小范围
		if cid < 1000 {
			cid += suijishu.Intn(101) + 200 // 生成 200 到 300 之间的随机整数 101 是 300 - 200 + 1 的结果
		} else if cid > 1000 {
			cid -= suijishu.Intn(401) + 500 // 生成 500 到 900 之间的随机整数 401 是 900 - 500 + 1 的结果
		}
		dianjicmd = make(map[int]map[string]string) //初始化点击对照
		//历遍cmdlb 导航
		for _, v := range cmdlb {
			cid++
			neirong += fmt.Sprintf("<a onclick=cmd(%d)>"+v+"</a> ", cid)
			dianjicmd[cid] = map[string]string{"cmd": v}
		}
		neirong += "<hr>"
		if cmd == "添加站点" {
			if shuju["addziduan"] != "" && shuju["addziduan2"] != "" {
				shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除所有非字母数字
				if shuju["addziduan2"] != "" {
					if shuju["addziduan2"] != "default" {
						//判断是否有效网址
						if isUrl(shuju["addziduan"]) {
							scheme, host, path, err := parseURL(shuju["addziduan"])
							if err == nil {
								if path == "/" || path == "" {
									shuju["addziduan"] = scheme + "://" + host
									//判断站点是否存在
									var ok = true
									lsweblb := weblb.R()
									websl := len(lsweblb)
									if websl > 0 {
										for _, v := range lsweblb {
											lsweb := web.R(v.I) //获取网站字段
											var sj2 []Ziduan
											json.Unmarshal([]byte(lsweb["webzd"]), &sj2) //序列化
											for _, v2 := range sj2 {
												if (v2.K == "link" && v2.V == shuju["addziduan"]) || (v2.K == "dir" && v2.V == shuju["addziduan2"]) {
													ok = false
													break
												}
											}
											if !ok {
												break
											}
										}
									}
									if ok {
										//添加站点 插入数据
										Db.Ping()                                                                                                                           //检测数据库是否连接
										ret, err := Db.Exec("INSERT INTO web (webzd,channelzd,articlezd,flinks,zaxiang,post) VALUES (?,?,?,?,?,?)", "", "", "", "", "", "") //执行sql语句
										if err != nil {
											ok = false
											return
										}
										//如果是插入数据的操作，能够拿到插入数据的id
										id, err := ret.LastInsertId()
										if err != nil {
											ok = false
											return
										}
										id2 := strconv.FormatInt(int64(id), 10)
										//添加网站列表
										lsweblb = append(lsweblb, Weblb{I: id2, U: shuju["addziduan"]})
										weblb.W(lsweblb)
										//反序列化
										var ziduan = webzd
										//历遍修改
										for lsid, v := range ziduan {
											if v.K == "link" {
												ziduan[lsid].V = shuju["addziduan"]
											} else if v.K == "dir" {
												ziduan[lsid].V = shuju["addziduan2"]
											}
										}
										//反序列化
										Bytes1, _ := json.Marshal(ziduan)
										Bytes2, _ := json.Marshal(channelzd)
										Bytes3, _ := json.Marshal(articlezd)
										Bytes4, _ := json.Marshal(flinkszd)
										Bytes5, _ := json.Marshal(zaxiangzd)
										Bytes6, _ := json.Marshal([]map[string]string{})
										Db.Ping() //检测数据库是否连接
										_, err = Db.Exec("UPDATE web SET webzd = ?, channelzd = ?, articlezd = ?, flinks = ?, zaxiang = ?, post = ? WHERE id = ?", Bytes1, Bytes2, Bytes3, Bytes4, Bytes5, Bytes6, id)
										if err != nil {
											Db.Ping() //检测数据库是否连接
											Db.Exec("DELETE FROM web WHERE id = ?", id)
											ok = false
										}
										if ok {
											dir2 := shuju["addziduan2"]

											newweb := map[string]string{
												"webzd":     string(Bytes1),
												"channelzd": string(Bytes2),
												"articlezd": string(Bytes3),
												"flinks":    string(Bytes4),
												"zaxiang":   string(Bytes5),
												"post":      string(Bytes6),
											}
											web.W(id2, newweb)
											newwebconfig := map[string]string{
												"id":    id2,
												"dir":   dir2,
												"muban": "default",
											}
											webconfig.W(host, newwebconfig)
											copydir("./init/templates/default", "./templates/"+dir2+"/default") //复制模板
											fs, _ := listFiles("./templates/" + dir2 + "/default")
											for _, v := range fs {
												fileName := filepath.Base(v)
												data, _ := os.ReadFile(v)
												newdata := `{{define "` + dir2 + `/default/` + fileName + `"}}<!--模板标识 请勿删除这行-->\n`
												newdata += string(data)
												newdata += `\n{{end}}<!--模板标识结束 请勿删除这行-->`
												newdata = strings.Replace(newdata, "\\n", "\n", -1)
												newdata = strings.ReplaceAll(newdata, "{{head}}", `{{template "`+dir2+`/default/head.htm".}}`)
												newdata = strings.ReplaceAll(newdata, "{{footer}}", `{{template "`+dir2+`/default/footer.htm".}}`)
												os.WriteFile("./templates/"+dir2+"/default/"+fileName, []byte(newdata), 0666)
											}
											updateTemplate() //更新模板
											neirong += "站点创建成功！<br>"
										} else {
											neirong += "站点创建失败！<br>"
										}

									} else {
										neirong += "站点已存在，或者网站目录被占用！<br>"
									}
								} else {
									neirong += "网站地址不是一个有效的地址！<br>"
								}
							} else {
								neirong += "网站地址不是一个有效的地址！<br>"
							}
						} else {
							neirong += "网站地址不是一个有效的地址！<br>"
						}
					} else {
						neirong += "default目录已经被使用！<br>"
					}
				} else {
					neirong += "网站保存目录不能为空！<br>"
				}
			} else {
				neirong += "网站地址和网站保存目录不能为空！<br>"
			}
		}
		//判断是否已经选中要管理的网站
		if wid == "" {
			var webid = cmds["webid"]
			if webid != "" {
				lsweb := web.R(webid)
				b := lsweb["webzd"]
				if b != "" {
					var sj2 []Ziduan
					//序列化
					json.Unmarshal([]byte(b), &sj2)
					for _, v2 := range sj2 {
						if v2.K == "link" {
							neirong += "开始管理的网站为：" + v2.V + "<br>"
							url = v2.V
						}
						if v2.K == "dir" {
							dir = v2.V
						}
					}
					if neirong != "" {
						hfmsg["main"] = neirong
					}
					wid = webid
					conn.Wid = wid
					user.W(uid, conn) //添加用户
					hfmsg["homeurl"] = url
					send(conn, hfmsg)
					continue
				} else {
					hfmsg["main"] = "当前没有任何网站，请先添加网站！"
					send(conn, hfmsg)
					continue
				}
			}
			lsweblb := weblb.R()
			websl := len(lsweblb)
			neirong += fmt.Sprintf("请选择要管理的网站(%d)：<br>", websl)
			if websl > 0 {
				for _, v := range lsweblb {
					cid++
					neirong += fmt.Sprintf("%s、<a onclick=cmd(%d)>%s</a><br>", v.I, cid, v.U)
					dianjicmd[cid] = map[string]string{"webid": v.I}
				}
			} else {
				neirong += "暂无网站，请先添加网站！"
			}
			neirong += "<p>---<br>添加站点："
			neirong += "<br>网站地址(如:http://abc.com): <input type=text name='addziduan' size='30' value=''>"
			neirong += "<br>网站保存目录(如:abc):<input type=text name='addziduan2' size='35' value=''>"
			neirong += "<br>---</p>"
			cid++
			neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
			dianjicmd[cid] = map[string]string{"cmd": "添加站点"}
			if neirong != "" {
				hfmsg["main"] = neirong
			}
			send(conn, hfmsg)
			continue
		}
		if cmd != "" {
			var cmd2 = cmds["cmd2"]
			var cmd3 = cmds["cmd3"]
			var cmd4 = cmds["cmd4"]
			var cmd5 = cmds["cmd5"]
			var lmid = cmds["lmid"]
			var yema = cmds["yema"]
			webid := cmds["webid"]
			switch cmd {
			case "首页":
				if cmd2 != "" {
					lsweb := web.R(webid)
					b := lsweb["webzd"]
					if cmd2 == "切换站点" {
						if b != "" {
							wid = webid
							conn.Wid = wid
							user.W(uid, conn) //添加用户
							var sj2 []Ziduan
							//序列化
							json.Unmarshal([]byte(b), &sj2)
							for _, v2 := range sj2 {
								if v2.K == "link" {
									neirong += "管理的网站切换为：" + v2.V + "<br>"
								}
								if v2.K == "dir" {
									dir = v2.V
								}
							}
						}
					} else if cmd2 == "删除站点" {
						if b != "" {
							var sj2 []Ziduan
							json.Unmarshal([]byte(b), &sj2) //序列化
							var link string
							for _, v2 := range sj2 {
								if v2.K == "link" {
									link = v2.V
									break
								}
							}
							if cmd3 != "" {
								var cmd4 = cmds["cmd4"]
								if cmd4 != "" {
									if Deletesite(webid) {
										//从网站列表删除
										neirong += "删除成功!"
										if wid == webid {
											wid = ""
										}
									} else {
										neirong += "删除失败!"
									}
								} else {
									neirong += "<p style='color:red;'>你将永久失去它，真的确定要删除站点：" + link + "?</p>"
									cid++
									neirong += fmt.Sprintf("<p><input type='button' value='确认删除' onclick=cmd(%d) required> ", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "删除站点", "webid": webid}
									cid++
									neirong += fmt.Sprintf("<p><input type='button' value='取消删除' onclick=cmd(%d) required> ", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd}
								}
							} else {
								neirong += "<p style='color:red;'>确定要删除站点：" + link + "?</p>"
								cid++
								neirong += fmt.Sprintf("<p><input type='button' value='确认删除' onclick=cmd(%d) required> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除站点", "webid": webid}
								cid++
								neirong += fmt.Sprintf("<p><input type='button' value='取消删除' onclick=cmd(%d) required> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd}
							}
						}
					}
				} else {
					if wid != "" {
						lsweb := web.R(wid)
						b := lsweb["webzd"]
						if b != "" {
							var sj2 []Ziduan
							//序列化
							json.Unmarshal([]byte(b), &sj2)
							for _, v2 := range sj2 {
								if v2.K == "link" {
									neirong += "当前管理的网站为：" + wid + "、" + v2.V + "<br>"
									break
								}
							}
						} else {
							wid = ""
						}
					}
					lsweblb := weblb.R()
					websl := len(lsweblb)
					neirong += fmt.Sprintf("请选择要管理的网站(%d)：<br>", websl)
					if websl > 0 {
						for _, v := range lsweblb {
							cid++
							neirong += fmt.Sprintf("%s、<a onclick=cmd(%d)>%s</a> ", v.I, cid, v.U)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "切换站点", "webid": v.I}
							if wid == v.I {
								neirong += " [管理中] "
							}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除站点</a>] <br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除站点", "webid": v.I}
						}
					} else {
						neirong += "暂无网站，请先添加网站！"
					}
					neirong += "<p>---<br>添加站点："
					neirong += "<br>网站地址(如:http://abc.com): <input type=text name='addziduan' size='30' value=''>"
					neirong += "<br>网站保存目录(如:abc):<input type=text name='addziduan2' size='35' value=''>"
					neirong += "<br>---</p>"
					cid++
					neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
					dianjicmd[cid] = map[string]string{"cmd": "添加站点"}
				}
			case "网站设置":
				lsweb := web.R(wid)
				var sj []Ziduan
				json.Unmarshal([]byte(lsweb["webzd"]), &sj)
				if cmd2 != "" {
					shuju["addziduan"] = removeInvalidChars(shuju["addziduan"])      //删除不是中文、字母和数字的字符
					shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除非字母和数字的字符
					shuju["cdir"] = removeNonAlphanumeric(shuju["cdir"])             //删除非字母和数字的字符
					shuju["adir"] = removeNonAlphanumeric(shuju["adir"])             //删除非字母和数字的字符
					//更新
					if shuju["addziduan"] != "" && shuju["addziduan2"] != "" && shuju["addziduan3"] != "" {
						if shuju["addziduan2"] != "addziduan" && shuju["addziduan2"] != "addziduan2" && shuju["addziduan2"] != "addziduan3" && regexp.MustCompile(`^[a-zA-Z]`).MatchString(shuju["addziduan2"]) {
							ok := true
							for _, v := range sj {
								if v.K == shuju["addziduan2"] {
									ok = false
								}
							}
							if ok {
								if shuju["addziduan3"] != "2" {
									shuju["addziduan3"] = "1"
								}
								sj = append(sj, Ziduan{shuju["addziduan"], shuju["addziduan2"], "", shuju["addziduan3"]})
								neirong += "新增字段成功<br>"
							} else {
								neirong += "新增字段名称重复<br>"
							}
						} else {
							neirong += "新增字段名称不可以是addziduan、addziduan2、addziduan3,且需要时字母开头<br>"
						}
					}
					var ok = true
					lssj := make(map[string]interface{})
					var oldurl, newurl string
					//历遍修改
					for lsid, v := range sj {
						if v.K != "dir" {
							if v.K == "link" {
								oldurl = v.V
								newurl = shuju[v.K]
							}
							if v.V != shuju[v.K] {
								if v.K == "link" {
									ok = false
									if shuju[v.K] != "" {
										sj[lsid].V = shuju[v.K]
										lssj[v.K] = shuju[v.K]
									} else {
										sj[lsid].V = v.V
										lssj[v.K] = v.V
										newurl = v.V
									}
								} else {
									sj[lsid].V = shuju[v.K]
									lssj[v.K] = shuju[v.K]
								}
							}
						}

					}
					if !ok {
						url = newurl
						//修改网站列表缓存
						lsweblb := weblb.R()
						for i, v := range lsweblb {
							if v.I == wid {
								lsweblb[i].U = shuju["link"]
							}
						}
						weblb.W(lsweblb)
						if oldurl != newurl && oldurl != "" && newurl != "" {
							_, ohost, _, _ := parseURL(oldurl)
							_, nhost, _, _ := parseURL(newurl)
							if ohost != "" && nhost != "" && ohost != nhost {
								lv, _ := webconfig.R(ohost)
								webconfig.W(nhost, lv)
								webconfig.D(ohost)
							}
						}
					}
					// 向管理同一个网站的用户推送数据
					lssj2 := make(map[string]interface{})
					lssj2["homeurl"] = shuju["link"]
					lssj2["all"] = make(map[string]interface{})
					lssj2["all"] = lssj
					send2(lssj2, wid)
					neirong += "修改成功<br>"
					b, _ := json.Marshal(sj) //将sj反序列化
					lsweb["webzd"] = string(b)
					web.W(wid, lsweb)
				}
				if cmd3 != "" && cmds["ziduan"] != "" {
					var ziduan = cmds["ziduan"]
					if ziduan == "link" || ziduan == "wap" || ziduan == "dir" || ziduan == "cdir" || ziduan == "adir" || ziduan == "title" || ziduan == "ftitle" || ziduan == "keywords" || ziduan == "homename" || ziduan == "description" || ziduan == "baidutoken" || ziduan == "beian" || ziduan == "copyright" {
						neirong += "link、wap、dir、cdir、adir、title、ftitle、keywords、homename、description、copyright、beian、baidutoken字段不可以删除！<br>"
					} else {
						if cmd4 != "" {
							var weizhi int
							//历遍获取字段位置
							for lsid, v := range sj {
								if v.K == ziduan {
									weizhi = lsid
									break
								}

							}
							sj = append(sj[:weizhi], sj[weizhi+1:]...)
							b, _ := json.Marshal(sj) //将sj反序列化
							lsweb["webzd"] = string(b)
							web.W(wid, lsweb)
							neirong += "成功删除 " + ziduan + " 字段!<br>"
						} else {
							neirong += "确定删除 " + ziduan + " 字段？<br>"
							cid++
							neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": cmd3, "cmd4": "删除", "ziduan": ziduan}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd}
							break
						}
					}
				}
				//历遍显示
				for _, v := range sj {
					cid++
					neirong += fmt.Sprintf("<p>"+v.N+" {{.w_"+v.K+"}}：<a onclick=cmd(%d)>[删除]</a><br>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "删除", "ziduan": v.K}
					if v.T == "1" {
						neirong += "<input type=text id='" + v.K + "' name='" + v.K + "' size='60' value='" + v.V + "'></p>"
					} else if v.T == "2" {
						neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' id='" + v.K + "' name='" + v.K + "'>" + v.V + "</textarea></p>"
					}
				}
				neirong += "<p>---<br>添加字段："
				neirong += "<br>字段说明(如:网站地址): <input type=text name='addziduan' size='30' value=''>"
				neirong += "<br>字段名称(如:links):<input type=text name='addziduan2' size='35' value=''>"
				neirong += "<br>字段类型(如:1代表单行文本、2代表多行文本): <input type=text name='addziduan3' size='7' value=''>"
				neirong += "<br>---</p>"
				cid++
				neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
				dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "更新"}
			case "栏目管理":
				lsweb := web.R(wid)
				hfmsg["up"] = ""
				if cmd2 != "" {
					if cmd2 == "添加栏目" {
						if cmd3 != "" {
							if shuju["title"] != "" {
								var zx map[string]string
								json.Unmarshal([]byte(lsweb["zaxiang"]), &zx)
								vid := zx["vid"]
								vid2, _ := strconv.Atoi(vid)
								vid2++
								vid3 := strconv.Itoa(vid2)
								zx["vid"] = vid3
								b2, _ := json.Marshal(zx)
								lsweb["zaxiang"] = string(b2)
								web.W(wid, lsweb)                                                                          //更新
								Db.Ping()                                                                                  //检测数据库是否连接
								Db.Exec("insert into channel (webid,vid,topid,shuju) values(?,?,?,?)", wid, vid3, "0", "") //执行sql语句
								var csj = make(map[string]string)                                                          //初始化栏目信息
								//获取栏目字段
								var sj []Ziduan
								json.Unmarshal([]byte(lsweb["channelzd"]), &sj)
								for _, v := range sj {
									if v.K == "neirong" {
										csj[v.K] = html.EscapeString(shuju[v.K]) //转义
									} else if v.K == "img" {
										if shuju[v.K] != "" {
											binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
											if err != nil {
												binaryData = []byte{}
											}
											var imgtype string
											if data.Imgtp != "" {
												if data.Imgtp == "image/png" {
													imgtype = ".png"
												} else if data.Imgtp == "image/jpeg" {
													imgtype = ".jpg"
												} else if data.Imgtp == "image/gif" {
													imgtype = ".gif"
												} else if data.Imgtp == "image/bmp" {
													imgtype = ".bmp"
												} else if data.Imgtp == "image/webp" {
													imgtype = ".webp"
												} else if data.Imgtp == "image/tiff" {
													imgtype = ".tiff"
												}
											}
											if imgtype != "" {
												filename := "/static/" + dir + "/up/channel/" + vid3 + imgtype // 定义要写入的文件名
												if savefile(filename, binaryData) {
													csj[v.K] = filename
												} else {
													csj[v.K] = "/static/nopic.png"
												}
											} else {
												csj[v.K] = "/static/nopic.png"
											}
										} else {
											csj[v.K] = "/static/nopic.png"
										}
									} else {
										csj[v.K] = html.EscapeString(shuju[v.K]) //转义
									}
								}

								if csj["topid"] == "0" {
									lschannellb := channellb.R(wid)
									lschannellb = append(lschannellb, vid3) //保存到顶级栏目列表
									channellb.W(wid, lschannellb)           //保存
								} else {
									//在上级栏目中添加下级栏目id
									csj2 := channel.R2(wid, csj["topid"]) //获取栏目
									if csj2["subid"] == "" {
										csj2["subid"] = vid3
									} else {
										csj2["subid"] = csj2["subid"] + "," + vid3
									}
									channel.W2(wid, csj["topid"], csj2) //更新栏目
								}
								csj["subid"] = ""
								csj["artid"] = ""
								b3, _ := json.Marshal(csj)                                                                          //将csj序列化
								channel.W2(wid, vid3, csj)                                                                          //添加栏目
								upmap(wid)                                                                                          //更新地图
								Db.Ping()                                                                                           //检测数据库是否连接
								Db.Exec(`update channel set topid=?,shuju=? where vid=?`, string(shuju["topid"]), string(b3), vid3) //更新数据库
								neirong = "栏目添加成功!<br>"
							} else {
								neirong += "栏目名称不能为空！"
							}
						} else {
							//获取并历遍栏目字段
							var sj []Ziduan
							json.Unmarshal([]byte(lsweb["channelzd"]), &sj)
							for _, v := range sj {
								if v.K == "subid" || v.K == "artid" {
									continue
								}
								neirong += "<p>" + v.N + "{{.c_" + v.K + "}}：<br>"
								if v.K == "lx" {
									neirong += "1代表列表/2代表单页<br>"
								}
								if v.T == "1" {
									neirong += "<input type=text name='" + v.K + "' size='60' value='" + v.V + "'></p>"
								} else if v.T == "2" {
									neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'></textarea></p>"
								} else if v.T == "4" {
									hfmsg["c"] = ""
								} else if v.T == "9" {
									if lmid == "" {
										lmid = "0"
									}
									neirong += "<input onfocus=this.blur() name='" + v.K + "' size='60' value='" + lmid + "'></p>"
								} else if v.T == "10" {
									neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' >"
									hfmsg["i"] = "1"
								}
							}
							cid++
							hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='点击提交' onclick=cmd2(%d) required></p>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd}
						}
					} else if cmd2 == "删除栏目" {
						if lmid != "" {
							//获取栏目信息
							csj := channel.R2(wid, lmid)
							if csj["title"] != "" {
								if cmd3 != "" {
									Deletechannel([]string{lmid}, wid) //删除栏目
									upmap(wid)                         //更新地图
									neirong += "删除成功!<br>"
								} else {
									neirong += "<p>确定删除栏目：" + csj["title"] + "以及栏目下所有文章?</p>"
									cid++
									hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='确认删除' onclick=cmd(%d) required> ", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除栏目", "lmid": lmid}
									cid++
									hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='取消删除' onclick=cmd(%d) required> ", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd}
								}
							} else {
								neirong += "栏目不存在！<br>"
							}
						} else {
							neirong += "栏目不存在！<br>"
						}
					} else if cmd2 == "修改栏目" {
						if lmid != "" {
							//获取栏目字段
							var sj []Ziduan
							json.Unmarshal([]byte(lsweb["channelzd"]), &sj)
							csj := channel.R2(wid, lmid)
							if cmd3 != "" {
								if shuju["title"] != "" {
									for _, v := range sj {
										if v.K == "topid" || v.K == "subid" || v.K == "artid" {
											continue
										}
										if v.K == "neirong" {
											csj[v.K] = html.EscapeString(shuju[v.K]) //转义
										} else if v.K == "img" {
											if shuju[v.K] != "" {
												binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
												if err != nil {
													binaryData = []byte{}
												}
												var imgtype string
												if data.Imgtp != "" {
													if data.Imgtp == "image/png" {
														imgtype = ".png"
													} else if data.Imgtp == "image/jpeg" {
														imgtype = ".jpg"
													} else if data.Imgtp == "image/gif" {
														imgtype = ".gif"
													} else if data.Imgtp == "image/bmp" {
														imgtype = ".bmp"
													} else if data.Imgtp == "image/webp" {
														imgtype = ".webp"
													} else if data.Imgtp == "image/tiff" {
														imgtype = ".tiff"
													}
												}
												if imgtype != "" {
													filename := "/static/" + dir + "/up/channel/" + lmid + imgtype // 定义要写入的文件名
													if savefile(filename, binaryData) {
														csj[v.K] = filename
													}
												}
											}
										} else {
											csj[v.K] = html.EscapeString(shuju[v.K]) //转义
										}
									}
									neirong += "栏目修改成功!<br>"
									channel.W2(wid, lmid, csj)
								} else {
									neirong += "请输入栏目名称！<br>"
								}
							} else {
								for _, v := range sj {
									if v.K == "subid" || v.K == "artid" {
										continue
									}
									neirong += "<p>" + v.N + "{{.c_" + v.K + "}}：<br>"
									if v.K == "lx" {
										neirong += "1代表列表/2代表单页<br>"
									}
									if v.T == "1" {
										neirong += "<input type=text name='" + v.K + "' size='60' value='" + csj[v.K] + "'></p>"
									} else if v.T == "2" {
										neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'>" + csj[v.K] + "</textarea></p>"
									} else if v.T == "4" {
										csj[v.K] = html.UnescapeString(csj[v.K]) //反转义
										hfmsg["c"] = csj[v.K]
									} else if v.T == "9" {
										neirong += csj[v.K] + "</p>"
									} else if v.T == "10" {
										if csj[v.K] != "" {
											neirong += "<img src='" + url + csj[v.K] + "' width='200'  ><br>"
										}
										neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' value='" + csj[v.K] + "'>"
										hfmsg["i"] = "1"
									}
								}
								cid++
								hfmsg["up"] += fmt.Sprintf("<input type='button' value='提交修改' onclick=cmd2(%d) required>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd, "lmid": lmid}
							}
						}
					} else if cmd2 == "查看栏目" {
						if lmid != "" {
							//获取栏目信息
							csj := channel.R2(wid, lmid)
							neirong += "<p>栏目：" + csj["title"] + "</p>"
							if cmd3 != "" {
								if cmd3 == "添加文章" {
									//获取文章字段
									var sj []Ziduan
									json.Unmarshal([]byte(lsweb["articlezd"]), &sj)
									if cmd4 != "" {
										if shuju["title"] != "" {
											var zx map[string]string
											json.Unmarshal([]byte(lsweb["zaxiang"]), &zx)
											aid := zx["aid"]
											aid2, _ := strconv.Atoi(aid)
											aid2++
											aid3 := strconv.Itoa(aid2)
											zx["aid"] = aid3
											b2, _ := json.Marshal(zx)
											lsweb["zaxiang"] = string(b2)
											web.W(wid, lsweb)                                                             //更新
											Db.Ping()                                                                     //检测数据库是否连接
											Db.Exec("insert into article (webid,aid,shuju) values(?,?,?)", wid, aid3, "") //执行sql语句
											//初始化文章数据
											var asj = make(map[string]string)
											for _, v := range sj {
												if v.K == "neirong" {
													asj[v.K] = html.EscapeString(shuju[v.K]) //转义
												} else if v.K == "img" {
													if shuju[v.K] != "" {
														binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
														if err != nil {
															binaryData = []byte{}
														}
														var imgtype string
														if data.Imgtp != "" {
															if data.Imgtp == "image/png" {
																imgtype = ".png"
															} else if data.Imgtp == "image/jpeg" {
																imgtype = ".jpg"
															} else if data.Imgtp == "image/gif" {
																imgtype = ".gif"
															} else if data.Imgtp == "image/bmp" {
																imgtype = ".bmp"
															} else if data.Imgtp == "image/webp" {
																imgtype = ".webp"
															} else if data.Imgtp == "image/tiff" {
																imgtype = ".tiff"
															}
														}
														if imgtype != "" {
															filename := "/static/" + dir + "/up/article/" + aid3 + imgtype // 定义要写入的文件名
															if savefile(filename, binaryData) {
																asj[v.K] = filename
															} else {
																asj[v.K] = "/static/nopic.png"
															}
														} else {
															asj[v.K] = "/static/nopic.png"
														}
													} else {
														asj[v.K] = "/static/nopic.png"
													}
												} else if v.K == "imgs" {
													var img_list []string
													imgs := data.Imgs
													if len(imgs) != 0 {
														//历遍imgs
														for _, v2 := range imgs {
															if v2["tp"] != "" && v2["ab"] != "" {
																binaryData, err := base64.StdEncoding.DecodeString(v2["ab"])
																if err != nil {
																	binaryData = []byte{}
																}
																var imgtype string
																if v2["tp"] != "" {
																	if v2["tp"] == "image/png" {
																		imgtype = ".png"
																	} else if v2["tp"] == "image/jpeg" {
																		imgtype = ".jpg"
																	} else if v2["tp"] == "image/gif" {
																		imgtype = ".gif"
																	} else if v2["tp"] == "image/bmp" {
																		imgtype = ".bmp"
																	} else if v2["tp"] == "image/webp" {
																		imgtype = ".webp"
																	} else if v2["tp"] == "image/tiff" {
																		imgtype = ".tiff"
																	}
																}
																if imgtype != "" {
																	filename := "/static/" + dir + "/up/article/" + aid3 + "_" + getrand(8) + imgtype // 定义要写入的文件名
																	if savefile(filename, binaryData) {
																		img_list = append(img_list, filename)
																	}
																}
															}
														}
													}
													asj[v.K] = strings.Join(img_list, ",")
												} else if v.K == "time" {
													asj[v.K] = strings.Split(html.EscapeString(shuju[v.K]), " m=")[0]
												} else {
													asj[v.K] = html.EscapeString(shuju[v.K]) //转义
												}
											}
											asj["topid"] = lmid
											article.W2(wid, aid3, asj)                                          //保存文章
											b2, _ = json.Marshal(asj)                                           //将csj序列化
											addartid(aid3, lmid, wid)                                           //将文章id添加到所属栏目下
											upmap(wid)                                                          //更新地图
											Db.Ping()                                                           //检测数据库是否连接
											Db.Exec(`update article set shuju=? where aid=?`, string(b2), aid3) //更新数据库
											neirong = "文章添加成功!<br>"
										} else {
											neirong += "文章标题不能为空！"
										}
									} else {
										//历遍文章字段
										for _, v := range sj {
											neirong += "<p>" + v.N + "{{.a_" + v.K + "}}：<br>"
											if v.T == "1" {
												neirong += "<input type=text name='" + v.K + "' size='60' value='" + v.V + "'></p>"
											} else if v.T == "2" {
												neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'></textarea></p>"
											} else if v.T == "4" {
												hfmsg["c"] = ""
												neirong += "</p>"
											} else if v.T == "5" {
												neirong += "<input onfocus=this.blur() name='" + v.K + "' value='" + lmid + "' /></p>"
											} else if v.T == "6" {
												neirong += fmt.Sprintf("<input type=text name='"+v.K+"' size='60' value='%s'></p>", time.Now())
											} else if v.T == "7" {
												neirong += "<input type=text name='" + v.K + "' size='60' value='0'></p>"
											} else if v.T == "9" {
												if lmid == "" {
													lmid = "0"
												}
												neirong += "<input onfocus=this.blur() name='" + v.K + "' size='60' value='" + lmid + "'></p>"
											} else if v.T == "10" {
												neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' >"
												hfmsg["i"] = "1"
											} else if v.T == "11" {
												neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' multiple='multiple'>"
												hfmsg["i"] = "1"
											}
										}
										cid++
										hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='点击提交' onclick=cmd2(%d) required></p>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd, "lmid": lmid}
									}
								} else if cmd3 == "修改文章" {
									if cmds["wzid"] != "" {
										wzid := cmds["wzid"]
										//获取文章信息
										asj := article.R2(wid, wzid)
										//获取文章字段
										var sj []Ziduan
										json.Unmarshal([]byte(lsweb["articlezd"]), &sj)
										if cmd4 != "" {
											if shuju["title"] != "" {
												for _, v := range sj {
													if v.K == "time" || v.K == "topid" {
														continue
													}
													if v.K == "neirong" {
														asj[v.K] = html.EscapeString(shuju[v.K]) //转义
													} else if v.K == "img" {
														if shuju[v.K] != "" {
															binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
															if err != nil {
																binaryData = []byte{}
															}
															var imgtype string
															if data.Imgtp != "" {
																if data.Imgtp == "image/png" {
																	imgtype = ".png"
																} else if data.Imgtp == "image/jpeg" {
																	imgtype = ".jpg"
																} else if data.Imgtp == "image/gif" {
																	imgtype = ".gif"
																} else if data.Imgtp == "image/bmp" {
																	imgtype = ".bmp"
																} else if data.Imgtp == "image/webp" {
																	imgtype = ".webp"
																} else if data.Imgtp == "image/tiff" {
																	imgtype = ".tiff"
																}
															}
															if imgtype != "" {
																filename := "/static/" + dir + "/up/article/" + wzid + imgtype // 定义要写入的文件名
																if savefile(filename, binaryData) {
																	asj[v.K] = filename
																}
															}
														}
													} else if v.K == "imgs" {
														img_list := strings.Split(asj["imgs"], ",") //转切片
														if img_list[0] == "" {
															img_list = []string{}
														}
														imgs := data.Imgs
														if len(imgs) != 0 {
															//历遍imgs
															for _, v2 := range imgs {
																if v2["tp"] != "" && v2["ab"] != "" {
																	binaryData, err := base64.StdEncoding.DecodeString(v2["ab"])
																	if err != nil {
																		binaryData = []byte{}
																	}
																	var imgtype string
																	if v2["tp"] != "" {
																		if v2["tp"] == "image/png" {
																			imgtype = ".png"
																		} else if v2["tp"] == "image/jpeg" {
																			imgtype = ".jpg"
																		} else if v2["tp"] == "image/gif" {
																			imgtype = ".gif"
																		} else if v2["tp"] == "image/bmp" {
																			imgtype = ".bmp"
																		} else if v2["tp"] == "image/webp" {
																			imgtype = ".webp"
																		} else if v2["tp"] == "image/tiff" {
																			imgtype = ".tiff"
																		}
																	}
																	if imgtype != "" {
																		filename := "/static/" + dir + "/up/article/" + wzid + "_" + getrand(8) + imgtype // 定义要写入的文件名
																		if savefile(filename, binaryData) {
																			img_list = append(img_list, filename)
																		}
																	}
																}
															}
														}
														asj[v.K] = strings.Join(img_list, ",")
													} else {
														asj[v.K] = html.EscapeString(shuju[v.K]) //转义
													}
												}
												article.W2(wid, wzid, asj)
												neirong = "文章修改成功!<br>"
											} else {
												neirong += "文章标题不能为空！"
											}
										} else {
											if cmd5 != "" && cmds["imgid"] != "" {
												imgid, _ := strconv.Atoi(cmds["imgid"])
												//删除图集
												imgs := strings.Split(asj["imgs"], ",") //转切片
												if imgid <= len(imgs) {
													imgs = append(imgs[:imgid], imgs[imgid+1:]...)
													asj["imgs"] = strings.Join(imgs, ",")
													article.W2(wid, wzid, asj)
												}
											}
											neirong += "<p>修改文章：" + asj["title"] + "</p>"
											//历遍文章字段
											for _, v := range sj {
												neirong += "<p>" + v.N + "{{.a_" + v.K + "}}：<br>"
												if v.T == "1" {
													neirong += "<input type=text name='" + v.K + "' size='60' value='" + asj[v.K] + "'></p>"
												} else if v.T == "2" {
													neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'>" + asj[v.K] + "</textarea></p>"
												} else if v.T == "4" {
													asj[v.K] = html.UnescapeString(asj[v.K]) //反转义
													hfmsg["c"] = asj[v.K]
													neirong += "</p>"
												} else if v.T == "5" {
													neirong += asj[v.K] + "</p>"
												} else if v.T == "6" {
													neirong += fmt.Sprintf("<input onfocus=this.blur() name='"+v.K+"' size='60' value='%s'></p>", asj[v.K])
												} else if v.T == "7" {
													neirong += "<input type=text name='" + v.K + "' size='60' value='" + asj[v.K] + "'></p>"
												} else if v.T == "10" {
													neirong += "<img src='" + url + asj[v.K] + "' width='200'  ><br>"
													neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' >"
													hfmsg["i"] = "1"
												} else if v.T == "11" {
													imgs := strings.Split(asj["imgs"], ",") //转切片
													if imgs[0] != "" {
														i := 0
														for ii, img := range imgs {
															i++
															neirong += fmt.Sprintf("%d.<img src='"+url+img+"' width='200'  >", i)
															cid++
															neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]<br>", cid)
															dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd5": cmd, "lmid": lmid, "wzid": wzid, "imgid": strconv.Itoa(ii)}
														}
													}
													neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' multiple='multiple'>"
													hfmsg["i"] = "1"
												}
											}
											cid++
											hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='提交修改' onclick=cmd2(%d) required></p>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd, "lmid": lmid, "wzid": wzid}
										}
									}
								} else if cmd3 == "删除文章" {
									if cmds["wzid"] != "" {
										wzid := cmds["wzid"]
										asj := article.R2(wid, wzid)
										if cmd4 != "" {
											Deletecontent([]string{wzid}, asj["topid"], wid)
											upmap(wid) //更新地图
											neirong += "删除成功!<br>"
										} else {
											//获取文章信息
											neirong += "<p>确定删除文章：" + asj["title"] + "?</p>"
											cid++
											neirong += fmt.Sprintf("<p><input type='button' value='确认删除' onclick=cmd2(%d) required></p>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd, "lmid": lmid, "wzid": wzid, "yema": yema}
											cid++
											neirong += fmt.Sprintf("<p><input type='button' value='取消删除' onclick=cmd2(%d) required></p>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "wzid": wzid, "yema": yema}
										}
									}
								}
								cid++
								hfmsg["up"] += fmt.Sprintf("<p>[<a onclick=cmd(%d) required>返回上一级</a>]</p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": yema}
							} else {
								if csj["lx"] != "1" {
									neirong += "单页栏目不能发布文章!<br>"
								} else {
									cid++
									neirong += fmt.Sprintf("<p>[<a onclick=cmd(%d)>添加文章</a>]</p>", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加文章", "lmid": lmid}
									var artid = strings.Split(csj["artid"], ",") //转切片
									var lsyema int
									if yema != "" {
										lsyema, _ = strconv.Atoi(yema)
									} else {
										lsyema = 1
									}
									var zsl = len(artid)                          //总数量
									var zyema = int(math.Ceil(float64(zsl) / 20)) //总页码
									//当前页码
									if lsyema > zyema && zyema > 0 {
										lsyema = zyema
									}
									var yemax = lsyema + 1 //下一页
									if yemax < 0 {
										yemax = 1
									}
									var yemas = lsyema - 1 //上一页
									if yemas < 0 {
										yemas = 1
									}
									kaishiid := (lsyema - 1) * 20 //开始id
									jieshuid := lsyema * 20       //结束id
									if jieshuid > zsl {
										jieshuid = zsl
									}
									i := kaishiid
									//截取artid
									artid = artid[kaishiid:jieshuid]
									if len(artid) > 0 && artid[0] != "" {
										for _, v := range artid {
											//获取文章数据
											asj := article.R2(wid, v)
											i++
											cid++
											t, _ := time.Parse("2006-01-02 15:04:05.999999999 -0700 MST", asj["time"])
											if asj["topid"] == lmid {
												neirong += fmt.Sprintf("%d.<a onclick=cmd(%d)>"+asj["title"]+"</a> [%s]", i, cid, t.Format("2006-01-02 15:04:05"))
											} else {
												//获取topid栏目数据
												tcsj := channel.R2(wid, asj["topid"])
												neirong += fmt.Sprintf("%d.<a onclick=cmd(%d)>"+asj["title"]+"</a> [%s] [%s]", i, cid, tcsj["title"], t.Format("2006-01-02 15:04:05"))
											}
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "修改文章", "lmid": lmid, "wzid": v, "yema": yema}
											cid++
											neirong += fmt.Sprintf(" [<a onclick=cmd(%d)>删除</a>]<br>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除文章", "lmid": lmid, "wzid": v, "yema": yema}
										}
										//创建页码
										ymif := ""
										if lsyema > 1 {
											cid++
											ymif += fmt.Sprintf("<a onclick=cmd(%d)>上页</a> ", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": strconv.Itoa(yemas)}

										}
										if jieshuid < zsl {
											cid++
											ymif += fmt.Sprintf("<a onclick=cmd(%d)>下.页</a> ", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": strconv.Itoa(yemax)}
										}
										if lsyema > 2 {
											cid++
											ymif += fmt.Sprintf("<a onclick=cmd(%d)>首页</a> ", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": "1"}
										}
										if zyema-lsyema > 1 {
											cid++
											ymif += fmt.Sprintf("<a onclick=cmd(%d)>末页</a> ", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": strconv.Itoa(zyema)}
										}
										if ymif != "" {
											neirong += "<br>" + ymif + "<br>"
										}
									} else {
										neirong += "暂无文章!<br>"
									}
								}
							}
						}
					} else if cmd2 == "栏目字段" {
						//获取栏目字段
						var sj []Ziduan
						json.Unmarshal([]byte(lsweb["channelzd"]), &sj)
						var bianhua = false
						//添加字段
						if cmd3 != "" {
							shuju["addziduan"] = removeInvalidChars(shuju["addziduan"])      //删除不是中文、字母和数字的字符
							shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除非字母和数字的字符
							if shuju["addziduan"] != "" && shuju["addziduan2"] != "" && shuju["addziduan3"] != "" {
								if shuju["addziduan2"] != "addziduan" && shuju["addziduan2"] != "addziduan2" && shuju["addziduan2"] != "addziduan3" && regexp.MustCompile(`^[a-zA-Z]`).MatchString(shuju["addziduan2"]) {
									ok := true
									var nid int
									for i, v := range sj {
										if v.K == shuju["addziduan2"] {
											ok = false
										}
										if v.K == "neirong" {
											nid = i
										}
									}
									if ok {
										if shuju["addziduan3"] != "2" {
											shuju["addziduan3"] = "1"
										}
										newData := make([]Ziduan, len(sj)+1)                                                    // 创建一个新的切片，长度比原来的切片多1
										copy(newData, sj[:nid])                                                                 // 复制前半部分
										newData[nid] = Ziduan{shuju["addziduan"], shuju["addziduan2"], "", shuju["addziduan3"]} // 插入新元素
										copy(newData[nid+1:], sj[nid:])                                                         // 复制后半部分
										sj = newData
										neirong += "新增字段成功<br>"
										bianhua = true
									} else {
										neirong += "新增字段名称重复<br>"
									}
								} else {
									neirong += "新增字段名称不可以是addziduan、addziduan2、addziduan3,且需要时字母开头<br>"
								}
							}
						}
						//删除字段
						if cmd4 != "" && cmds["ziduan"] != "" {
							var ziduan = cmds["ziduan"]
							ok := true
							//循环判断是否为栏目默认字段
							for _, v := range channelzd {
								if v.K == ziduan {
									ok = false
								}
							}
							if !ok {
								neirong += "栏目自带字段不可以删除！<br>"
							} else {
								if cmd5 != "" {
									var nid int
									//历遍获取字段位置
									for i, v := range sj {
										if v.K == ziduan {
											nid = i
											break
										}
									}
									sj = append(sj[:nid], sj[nid+1:]...)
									bianhua = true
									neirong += "成功删除 " + ziduan + " 字段!<br>"
								} else {
									neirong += "确定删除 " + ziduan + " 字段？<br>"
									cid++
									neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": "删除", "ziduan": ziduan}
									cid++
									neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2}
									break
								}
							}
						}
						if bianhua {
							b, _ := json.Marshal(sj) //将sj反序列化
							lsweb["channelzd"] = string(b)
							web.W(wid, lsweb)
						}
						for _, v := range sj {
							cid++
							neirong += fmt.Sprintf(v.N+" {{.c_"+v.K+"}}：<a onclick=cmd(%d)>[删除]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd4": "删除", "ziduan": v.K}
						}
						neirong += "<p>---<br>添加字段："
						neirong += "<br>字段说明(如:栏目标题): <input type=text name='addziduan' size='30' value=''>"
						neirong += "<br>字段名称(如:title):<input type=text name='addziduan2' size='35' value=''>"
						neirong += "<br>字段类型(如:1代表单行文本、2代表多行文本): <input type=text name='addziduan3' size='7' value=''>"
						neirong += "<br>---</p>"
						cid++
						neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
						dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加字段"}
					} else if cmd2 == "文章字段" {
						//获取文章
						var sj []Ziduan
						json.Unmarshal([]byte(lsweb["articlezd"]), &sj)
						var bianhua = false
						//添加字段
						if cmd3 != "" {
							shuju["addziduan"] = removeInvalidChars(shuju["addziduan"])      //删除不是中文、字母和数字的字符
							shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除非字母和数字的字符
							if shuju["addziduan"] != "" && shuju["addziduan2"] != "" && shuju["addziduan3"] != "" {
								if shuju["addziduan2"] != "addziduan" && shuju["addziduan2"] != "addziduan2" && shuju["addziduan2"] != "addziduan3" && regexp.MustCompile(`^[a-zA-Z]`).MatchString(shuju["addziduan2"]) {
									ok := true
									var nid int
									for i, v := range sj {
										if v.K == shuju["addziduan2"] {
											ok = false
										}
										if v.K == "neirong" {
											nid = i
										}
									}
									if ok {
										if shuju["addziduan3"] != "2" {
											shuju["addziduan3"] = "1"
										}
										newData := make([]Ziduan, len(sj)+1)                                                    // 创建一个新的切片，长度比原来的切片多1
										copy(newData, sj[:nid])                                                                 // 复制前半部分
										newData[nid] = Ziduan{shuju["addziduan"], shuju["addziduan2"], "", shuju["addziduan3"]} // 插入新元素
										copy(newData[nid+1:], sj[nid:])                                                         // 复制后半部分
										sj = newData
										neirong += "新增字段成功<br>"
										bianhua = true
									} else {
										neirong += "新增字段名称重复<br>"
									}
								} else {
									neirong += "新增字段名称不可以是addziduan、addziduan2、addziduan3,且需要时字母开头<br>"
								}
							}
						}
						//删除字段
						if cmd4 != "" && cmds["ziduan"] != "" {
							var ziduan = cmds["ziduan"]
							ok := true
							//循环判断是否为文章默认字段
							for _, v := range articlezd {
								if v.K == ziduan {
									ok = false
								}
							}
							if !ok {
								neirong += "文章自带字段不可以删除！<br>"
							} else {
								if cmd5 != "" {
									var nid int
									//历遍获取字段位置
									for i, v := range sj {
										if v.K == ziduan {
											nid = i
											break
										}
									}
									sj = append(sj[:nid], sj[nid+1:]...)
									bianhua = true
									neirong += "成功删除 " + ziduan + " 字段!<br>"
								} else {
									neirong += "确定删除 " + ziduan + " 字段？<br>"
									cid++
									neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": "删除", "ziduan": ziduan}
									cid++
									neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2}
									break
								}
							}
						}
						if bianhua {
							b, _ := json.Marshal(sj) //将sj反序列化
							lsweb["articlezd"] = string(b)
							web.W(wid, lsweb)
						}
						for _, v := range sj {
							cid++
							neirong += fmt.Sprintf(v.N+" {{.a_"+v.K+"}}：<a onclick=cmd(%d)>[删除]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd4": "删除", "ziduan": v.K}
						}
						neirong += "<p>---<br>添加字段："
						neirong += "<br>字段说明(如:文章标题): <input type=text name='addziduan' size='30' value=''>"
						neirong += "<br>字段名称(如:title):<input type=text name='addziduan2' size='35' value=''>"
						neirong += "<br>字段类型(如:1代表单行文本、2代表多行文本): <input type=text name='addziduan3' size='7' value=''>"
						neirong += "<br>---</p>"
						cid++
						neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
						dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加字段"}
					}
					cid++
					hfmsg["up"] += fmt.Sprintf("<p><a onclick=cmd(%d)>[返回栏目]</a></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd}
				} else {
					cid++
					neirong += fmt.Sprintf("<p><a onclick=cmd(%d)>[添加栏目]</a> ", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "添加栏目"}
					cid++
					neirong += fmt.Sprintf("<a onclick=cmd(%d)>[栏目字段]</a> ", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "栏目字段"}
					cid++
					neirong += fmt.Sprintf("<a onclick=cmd(%d)>[文章字段]</a></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "文章字段"}
					//获取顶级栏目列表
					lschannellb := channellb.R(wid)
					zsl := len(lschannellb)
					if cmd3 != "" && cmds["chid"] != "" {
						//将cmds["chid"]转int
						id, _ := strconv.Atoi(cmds["chid"])
						if cmd3 == "向上" && id > 0 {
							lschannellb[id], lschannellb[id-1] = lschannellb[id-1], lschannellb[id]
							channellb.W(wid, lschannellb) //保存顶级栏目列表
						} else if cmd3 == "向下" && id < zsl-1 {
							lschannellb[id], lschannellb[id+1] = lschannellb[id+1], lschannellb[id]
							channellb.W(wid, lschannellb) //保存顶级栏目列表
						}
					}
					if zsl > 0 {
						var i = 0
						for id, v := range lschannellb {
							//获取顶级栏目信息
							csj := channel.R2(wid, v)
							//历遍获取栏目title、下属栏目、下属文章
							var title string = csj["title"]
							var subid []string = strings.Split(csj["subid"], ",")
							//var artid []string = strings.Split(csj["artid"], ",")
							var lx string = csj["lx"]
							i++
							cid++
							if lx == "1" {
								lx = "列表"
								var artid []string = strings.Split(csj["artid"], ",")
								wzsl := len(artid)
								if artid[0] == "" {
									wzsl = 0
								}
								neirong += fmt.Sprintf("%d. <a onclick=cmd(%d)>"+title+"</a>[id:"+v+"]["+lx+"][%d] ", i, cid, wzsl)
							} else {
								lx = "单页"
								neirong += fmt.Sprintf("%d. <a onclick=cmd(%d)>"+title+"</a>[id:"+v+"]["+lx+"] ", i, cid)
							}
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "查看栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>修改</a>]", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "修改栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>添加</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "添加栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>向上</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "向上", "chid": strconv.Itoa(id)}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>向下</a>]<br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "向下", "chid": strconv.Itoa(id)}
							//获取二级栏目列表
							if len(subid) > 0 && subid[0] != "" {
								for _, v3 := range subid {
									//获取二级栏目信息
									csj := channel.R2(wid, v3)
									//历遍获取栏目title、下属栏目、下属文章
									var title string = csj["title"]
									//var subid []string = strings.Split(csj["subid"], ",")
									//var artid []string = strings.Split(csj["artid"], ",")
									var lx string = csj["lx"]
									cid++
									if lx == "1" {
										lx = "列表"
										var artid []string = strings.Split(csj["artid"], ",")
										wzsl := len(artid)
										if artid[0] == "" {
											wzsl = 0
										}
										neirong += fmt.Sprintf(" &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-<a onclick=cmd(%d)>"+title+"</a>[id:"+v3+"]["+lx+"][%d] ", cid, wzsl)
									} else {
										lx = "单页"
										neirong += fmt.Sprintf(" &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-<a onclick=cmd(%d)>"+title+"</a>[id:"+v3+"]["+lx+"] ", cid)
									}
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "查看栏目", "lmid": v3}
									cid++
									neirong += fmt.Sprintf("[<a onclick=cmd(%d)>修改</a>]", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "修改栏目", "lmid": v3}
									cid++
									neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]<br>", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除栏目", "lmid": v3}
									// cid++
									// neirong += fmt.Sprintf("[<a onclick=cmd(%d)>添加子栏目</a>]", cid)
									// dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "添加栏目", "lmid": v}
								}
							}
							neirong += "<br>"
						}
					}
				}
			case "友情链接":
				//获取友情连接
				lsweb := web.R(wid)
				var flinks []FriendLink
				json.Unmarshal([]byte(lsweb["flinks"]), &flinks)
				if cmd3 != "" {
					if cmds["finkid"] != "" {
						finkid, _ := strconv.Atoi(cmds["finkid"])
						if cmd3 == "删除链接" {
							if cmd4 != "" {
								if finkid <= len(flinks) {
									flinks = append(flinks[:finkid], flinks[finkid+1:]...)
									b, _ := json.Marshal(flinks)
									lsweb["flinks"] = string(b)
									web.W(wid, lsweb) //更新
								}
								neirong += "友情链接删除功!<br>"
							} else {
								neirong += "<p>确定删除：" + flinks[finkid].N + flinks[finkid].U + "?</p>"
								cid++
								neirong += fmt.Sprintf("<input type='button' value='确定删除' onclick=cmd(%d) required></p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": cmd3, "cmd4": cmd, "finkid": strconv.Itoa(finkid)}
								cid++
								neirong += fmt.Sprintf("<input type='button' value='取消删除' onclick=cmd(%d) required></p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd}
							}
						} else if cmd3 == "修改链接" {
							if cmd4 != "" {
								if shuju["title"] != "" && shuju["url"] != "" {
									flinks[finkid].N = shuju["title"]
									flinks[finkid].U = shuju["url"]
									neirong += "友情链接修改成功!<br>"
									b, _ := json.Marshal(flinks)
									lsweb["flinks"] = string(b)
									web.W(wid, lsweb) //更新
								} else {
									neirong += "友情链接名称不能为空!<br>"
								}
							} else {
								neirong += "<p>网站名称：<input type='text' name='title' value='" + flinks[finkid].N + "'></p>"
								neirong += "<p>网站地址：<input type='text' name='url' value='" + flinks[finkid].U + "'></p>"
								cid++
								neirong += fmt.Sprintf("<input type='button' value='修改友情链接' onclick=cmd2(%d) required></p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": cmd3, "cmd4": cmd, "finkid": strconv.Itoa(finkid)}
							}
						}
					}
				} else {
					if cmd2 != "" {
						if shuju["title"] != "" && shuju["url"] != "" {
							flinks = append(flinks, FriendLink{shuju["title"], shuju["url"]})
							b, _ := json.Marshal(flinks)
							lsweb["flinks"] = string(b)
							web.W(wid, lsweb) //更新
						} else {
							neirong += "友情链接名称不能为空!<br>"
						}
					}
					neirong += "<p>网站名称：<input type='text' name='title'></p>"
					neirong += "<p>网站地址：<input type='text' name='url'></p>"
					cid++
					neirong += fmt.Sprintf("<input type='button' value='添加友情链接' onclick=cmd2(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd}
					//历遍友情连接
					if len(flinks) > 0 {
						i := 0
						for ii, v := range flinks {
							i++
							cid++
							neirong += fmt.Sprintf("%d. 名称：%s  链接：[%s] [<a onclick=cmd(%d)>修改</a>]", i, v.N, v.U, cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "修改链接", "finkid": strconv.Itoa(ii)}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]<br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "删除链接", "finkid": strconv.Itoa(ii)}
						}
					}
				}
			case "数据备份":
				if cmd2 != "" {
					neirong += backup_data(wid)
				}
				cid++
				neirong += fmt.Sprintf("<p><a onclick=cmd(%d) required>新建备份</a></p>", cid)
				dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "新建备份"}
			case "数据还原":
				backupdir := "./backup/" + dir //备份目录
				files, err := listFiles(backupdir)
				if err != nil {
					neirong += "没有备份文件<br>"
				}
				if cmd2 != "" && cmds["filename"] != "" {
					filename := cmds["filename"]
					if cmd2 == "还原" {
						if cmd3 != "" {
							neirong += restore_data(filename, wid)
						} else {
							neirong += "确定还原备份数据：" + filename + "?<br>"
							cid++
							neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定还原]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "还原", "filename": filename, "yema": yema}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消还原]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						}
					} else if cmd2 == "删除" {
						if cmd3 != "" {
							err := os.Remove(filename)
							if err != nil {
								neirong += "备份数据：" + filename + "删除失败<br>"
							} else {
								neirong += "备份数据：" + filename + "删除成功<br>"
							}
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[返回上级]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						} else {
							neirong += "确定删除备份数据：" + filename + "?<br>"
							cid++
							neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除", "filename": filename, "yema": yema}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						}
					} else if cmd2 == "下载" {
						fileN := path.Base(filename)
						var ok = true
						data, err := os.ReadFile(filename)
						if err != nil {
							ok = false
						}
						// 将读取的内容转换为字符串
						content := string(data)
						if ok {
							hfmsg["downneirong"] = content
							hfmsg["downname"] = fileN
							neirong += "<button id='downloadBtn'>下载</button>"
						} else {
							neirong += "文件不存在！<br>"
						}
					} else if cmd2 == "重命名" {
						if cmd3 != "" {
							newfilename := removeNonAlphanumeric(shuju["addziduan"])
							if newfilename != "" {
								ext := path.Ext(newfilename)
								if ext != ".json" {
									newfilename = backupdir + "/" + newfilename + ".json"
								} else {
									newfilename = backupdir + "/" + newfilename
								}
								err := os.Rename(filename, newfilename)
								if err != nil {
									neirong += "备份数据：" + filename + "重命名失败<br>"
								} else {
									neirong += "备份数据：" + filename + "重命名成功<br>"
								}
							} else {
								neirong += "新名称只能由字母和数字组成<br>"
							}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[返回上级]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						} else {
							neirong += "<p>---<br>重命名：<br>"
							neirong += "旧名称：" + filename + "<br>新名称：<input type=text name='addziduan' size='30' value=''>"
							neirong += "<br>---</p>"
							cid++
							neirong += fmt.Sprintf("<input type='button' value='重命名' onclick=cmd2(%d) required>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "重命名", "filename": filename, "yema": yema}
						}
					}
				} else {
					zsl := len(files)
					if zsl > 0 {
						//页码
						var lsyema int
						if yema != "" {
							lsyema, _ = strconv.Atoi(yema)
						} else {
							lsyema = 1
						}
						ymif := ""
						if lsyema > 1 {
							ls := lsyema - 1
							cid++
							ymif += fmt.Sprintf("<a onclick=cmd(%d) required>上页</a> ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "yema": strconv.Itoa(ls)}
						}
						if zsl > lsyema*20 {
							ls := lsyema + 1
							cid++
							ymif += fmt.Sprintf("<a onclick=cmd(%d) required>下页</a></br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "yema": strconv.Itoa(ls)}
						}
						kaishiid := (lsyema - 1) * 20
						jieshuid := lsyema * 20 //结束id
						if jieshuid > zsl {
							jieshuid = zsl
						}
						lsfileList := files[kaishiid:jieshuid]
						if len(lsfileList) > 0 && lsfileList[0] != "" {
							for _, v := range lsfileList {
								cid++
								kaishiid++
								size, _ := getFileSize("./" + v)
								neirong += fmt.Sprintf("%d.%s [%.2f KB]<a onclick=cmd(%d) required>[还原]</a> ", kaishiid, v, size, cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "还原", "filename": v, "yema": yema}
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d) required>[删除]</a> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除", "filename": v, "yema": yema}
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d) required>[下载]</a> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "下载", "filename": v, "yema": yema}
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d) required>[重命名]</a></br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "重命名", "filename": v, "yema": yema}
							}
						}
						if ymif != "" {
							neirong += ymif
						}
					} else {
						neirong += "没有任何备份！<br>"
					}
				}
			case "网站更新":
				if cmd2 != "" {
					if cmd2 == "一键更新地图" {
						upmap(wid)
						neirong += "./sitemap.xml<br>./sitemap.txt<br>./sitemap.html<br>更新地图完成！"
					}
					if cmd2 == "更新模板缓存" {
						fh := updateTemplate() //更新模板
						if fh != "1" {
							re := regexp.MustCompile(`template: ([^:]+):(\d+):`) // 定义正则表达式
							match := re.FindStringSubmatch(fh)                   // 查找匹配
							if match != nil {
								neirong += match[1] + "第" + match[2] + "行出错，模板新建失败！<br>"
							}
						} else {
							neirong += "更新模板缓存成功！<br>"
						}
					}
				} else {
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='一键更新地图' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "一键更新地图"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='更新模板缓存' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "更新模板缓存"}
				}
			case "系统维护":
				if cmd2 != "" {
					lsweb := web.R(wid)
					if cmd2 == "网站模板管理" {
						var sj2 map[string]string
						json.Unmarshal([]byte(lsweb["zaxiang"]), &sj2)
						//mulu := "./templates/" + dir + "/" + sj2["muban"]
						if cmd3 != "" {
							if cmds["mubandir"] != "" {
								mubandir := cmds["mubandir"]
								if cmd3 == "查看模板" {
									if cmd4 != "" {
										if cmd4 == "新建模板" {
											if cmd5 != "" {
												if shuju["mubanming"] != "" && shuju["mubanneirong"] != "" {
													lsmbname := "./templates/" + dir + "/" + mubandir + "/" + shuju["mubanming"] + ".htm"
													if !fileExists(lsmbname) && shuju["mubanming"] != "404" {
														newdata := `{{define "` + dir + `/` + mubandir + `/` + shuju["mubanming"] + `.htm"}}<!--请勿删除这行-->\n`
														newdata += shuju["mubanneirong"]
														newdata += `\n{{end}}<!--请勿删除这行-->`
														newdata = strings.Replace(newdata, "\\n", "\n", -1)
														savefile(lsmbname, []byte(newdata))
														if mubandir == sj2["muban"] {
															fh := updateTemplate() //更新模板
															if fh != "1" {
																re := regexp.MustCompile(`template: ([^:]+):(\d+):`) // 定义正则表达式
																match := re.FindStringSubmatch(fh)                   // 查找匹配
																i, _ := strconv.Atoi(match[2])
																i--
																if match != nil {
																	neirong += match[1] + "第" + strconv.Itoa(i) + "行出错，模板新建失败！<br>"
																}
																os.Remove(lsmbname) //删除文件
																neirong += "将在" + dir + "/" + mubandir + "/下新建模板：<br><p>"
																neirong += "<p>模板名(如：index)：<input type='text' name='mubanming' value='" + shuju["mubanming"] + "'><br></p>"
																neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
																neirong += "<p><textarea id='mubanneirong' name='mubanneirong' style='font-family: monospace; white-space: pre;resize: none;background-color:#1C1C1C;color: #8B814C;width:90%;overflow:auto;word-break:break-all;' cols='60' rows='40'>" + shuju["mubanneirong"] + "</textarea><br></p>"
																cid++
																neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
																dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir}
															} else {
																neirong += shuju["mubanming"] + ".htm<br>模板新建成功！<br>"
															}
														}
													} else {
														neirong += shuju["mubanming"] + ".htm 模板已存在！<br>"
													}
												} else {
													neirong += "模板名称和内容不能为空！<br>"
												}
											} else {
												neirong += "将在" + dir + "/" + mubandir + "/下新建模板：<br><p>"
												neirong += "<p>模板名(如：index)：<input type='text' name='mubanming' value=''><br></p>"
												neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
												neirong += "<p><textarea id='mubanneirong' name='mubanneirong' style='font-family: monospace; white-space: pre;resize: none;background-color:#1C1C1C;color: #8B814C;width:90%;overflow:auto;word-break:break-all;' cols='60' rows='40'></textarea><br></p>"
												cid++
												neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
												dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir}
											}
										} else if cmd4 == "修改模板" {
											if cmds["mubanname"] != "" {
												mubanname := cmds["mubanname"]
												lsmbname := "./templates/" + dir + "/" + mubandir + "/" + mubanname
												odata, err := os.ReadFile(lsmbname)
												if cmd5 != "" {
													if shuju["mubanming"] != "" && shuju["mubanneirong"] != "" {
														savefile(lsmbname, []byte(shuju["mubanneirong"]))
														fh := updateTemplate() //更新模板
														if fh != "1" {
															re := regexp.MustCompile(`template: ([^:]+):(\d+):`) // 定义正则表达式
															match := re.FindStringSubmatch(fh)                   // 查找匹配
															if match != nil {
																neirong += match[1] + "第" + match[2] + "行出错，修改失败！<br>"
															}
															savefile(lsmbname, []byte(odata)) //恢复
															neirong += "修改" + dir + "/" + mubandir + "/" + mubanname + "：<br>"
															neirong += "<p>模板名：<input type='text' onfocus=this.blur() name='mubanming' value='" + mubanname + "'><br></p>"
															neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
															neirong += "<p><textarea id='mubanneirong' name='mubanneirong' style='font-family: monospace; white-space: pre;resize: none;background-color:#1C1C1C;color: #8B814C;width:90%;overflow:auto;word-break:break-all;' cols='60' rows='40'>" + string(shuju["mubanneirong"]) + "</textarea><br></p>"
															cid++
															neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
															dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir, "mubanname": mubanname}
														} else {
															neirong += shuju["mubanming"] + "<br>模板修改成功！<br>"
														}
													} else {
														neirong += "模板名称和内容不能为空！<br>"
													}
												} else {
													if err != nil {
														neirong += "模板文件不存在！<br>"
													} else {
														neirong += "修改" + dir + "/" + mubandir + "/" + mubanname + "：<br>"
														neirong += "<p>模板名：<input type='text' onfocus=this.blur() name='mubanming' value='" + mubanname + "'><br></p>"
														neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
														neirong += "<p><textarea id='mubanneirong' name='mubanneirong' style='font-family: monospace; white-space: pre;resize: none;background-color:#1C1C1C;color: #8B814C;width:90%;overflow:auto;word-break:break-all;' cols='60' rows='40'>" + string(odata) + "</textarea><br></p>"
														cid++
														neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
														dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir, "mubanname": mubanname}
													}
												}
											}
										} else if cmd4 == "删除模板" {
											if cmds["mubanname"] != "" {
												mubanname := cmds["mubanname"]
												if cmd5 != "" {
													path := "./templates/" + dir + "/" + mubandir + "/" + mubanname
													os.Remove(path) //删除文件
													neirong += "删除成功<br>"
													fh := updateTemplate() //更新模板
													if fh != "1" {
														neirong += "模板错误，模板更新失败！<br>"
													}
												} else {
													neirong += "确定删除" + mubandir + "/" + mubanname + "？<br>"
													cid++
													neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
													dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir, "mubanname": mubanname}
													cid++
													neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
													dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "mubandir": mubandir}
												}
											}
										}
										cid++
										neirong += fmt.Sprintf("<a onclick=cmd(%d)>返回上一级</a><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "mubandir": mubandir}
									} else {
										cid++
										neirong += fmt.Sprintf(" [<a onclick=cmd(%d)>新建</a>]<br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "新建模板", "mubandir": mubandir}
										fs, _ := listFiles("./templates/" + dir + "/" + mubandir)
										if len(fs) > 0 {
											i := 0
											for _, v := range fs {
												fileName := filepath.Base(v)
												i++
												cid++
												size, _ := getFileSize("./templates/" + dir + "/" + mubandir + "/" + fileName)
												neirong += fmt.Sprintf("%d、%s (%.2f KB) [<a onclick=cmd(%d)>修改</a>] ", i, fileName, size, cid)
												dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "修改模板", "mubandir": mubandir, "mubanname": fileName}
												cid++
												neirong += fmt.Sprintf(" [<a onclick=cmd(%d)>删除</a>]<br>", cid)
												dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "删除模板", "mubandir": mubandir, "mubanname": fileName}
											}
										} else {
											neirong += "没有任何模板文件<br>"
										}
									}
								} else if cmd3 == "切换模板" {
									sj2["muban"] = cmds["mubandir"]
									b2, _ := json.Marshal(sj2)
									lsweb["zaxiang"] = string(b2)
									web.W(wid, lsweb) //更新数据
									_, host, _, _ := parseURL(url)
									if host != "" {
										//切换模板后修改配置信息
										lswebconfig, _ := webconfig.R(wid)
										lswebconfig["muban"] = cmds["mubandir"]
										webconfig.W(wid, lswebconfig)
									}
									neirong += "切换模板成功！<br>"
								} else if cmd3 == "删除模板" {
									if cmd4 != "" {
										deleteDirectory("./templates/" + dir + "/" + mubandir)
										deleteDirectory("./static/" + dir + "/" + mubandir)
										neirong += "删除模板成功！<br>"
										fh := updateTemplate() //更新模板
										if fh != "1" {
											neirong += "模板错误，模板更新失败！<br>"
										}
									} else {
										neirong += "确定删除模板：" + mubandir + "?<br>"
										cid++
										neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "删除模板", "mubandir": mubandir}
										cid++
										neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2}
									}
								}
							}
							cid++
							neirong += fmt.Sprintf("<br><a onclick=cmd(%d)>[返回模板管理]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2}
						} else {
							neirong += "当前使用的模板为：" + sj2["muban"] + "<br>"
							neirong += "当前网站模板有：<br>"
							mls, _ := getSubDirectories("./templates/" + dir)
							if len(mls) == 0 {
								neirong += "没有模板文件！"
							} else {
								i := 0
								for _, v := range mls {
									i++
									if v == sj2["muban"] {
										neirong += fmt.Sprintf("%d、%s [正在使用]", i, v)
										cid++
										neirong += fmt.Sprintf("[<a onclick=cmd(%d)>查看</a>]<br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "查看模板", "mubandir": v}
									} else {
										if v == "default" {
											cid++
											neirong += fmt.Sprintf("%d、 %s  [<a onclick=cmd(%d)>查看</a>] ", i, v, cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "查看模板", "mubandir": v}
											cid++
											neirong += fmt.Sprintf("[<a onclick=cmd(%d)>使用</a>]<br>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "切换模板", "mubandir": v}
										} else {
											cid++
											neirong += fmt.Sprintf("%d、 %s  [<a onclick=cmd(%d)>查看</a>] ", i, v, cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "查看模板", "mubandir": v}
											cid++
											neirong += fmt.Sprintf("[<a onclick=cmd(%d)>使用</a>] ", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "切换模板", "mubandir": v}
											cid++
											neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]<br>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除模板", "mubandir": v}
										}
									}
								}
							}

						}

					} else if cmd2 == "网站模板采集" {
						neirong += "网站模板采集：<br>"
						neirong += "<div id='infos'></div>"
						if cmd3 != "" {
							if shuju["caiji"] == "1" || shuju["caiji"] == "2" {
								caijiurl := make(map[string]map[string]string)
								caijipczd := map[string]string{
									"caijipc1": "index.htm",
									"caijipc2": "c_index.htm",
									"caijipc3": "c_images.htm",
									"caijipc4": "c_list.htm",
									"caijipc5": "a_images.htm",
									"caijipc6": "a_article.htm",
									"caijipc7": "search.htm",
								}
								caijimzd := map[string]string{
									"caijim1": "index_m.htm",
									"caijim2": "c_index_m.htm",
									"caijim3": "c_images_m.htm",
									"caijim4": "c_list_m.htm",
									"caijim5": "a_images_m.htm",
									"caijim6": "a_article_m.htm",
									"caijim7": "search_m.htm",
								}
								if shuju["caiji"] == "1" {
									if isUrl(shuju["caijipc1"]) && isUrl(shuju["caijipc2"]) && isUrl(shuju["caijipc4"]) && isUrl(shuju["caijipc6"]) {
										caijiurl["pc"] = make(map[string]string)
										for k, v := range caijipczd {
											if isUrl(shuju[k]) {
												caijiurl["pc"][v] = shuju[k]
											}
										}
									} else {
										neirong += "采集电脑版网址出错！<br>"
									}
								} else if shuju["caiji"] == "2" {
									if isUrl(shuju["caijipc1"]) && isUrl(shuju["caijipc2"]) && isUrl(shuju["caijipc4"]) && isUrl(shuju["caijipc6"]) && isUrl(shuju["caijim1"]) && isUrl(shuju["caijim2"]) && isUrl(shuju["caijim4"]) && isUrl(shuju["caijim6"]) {
										caijiurl["pc"] = make(map[string]string)
										caijiurl["m"] = make(map[string]string)
										for k, v := range caijipczd {
											if isUrl(shuju[k]) {
												caijiurl["pc"][v] = shuju[k]
											}
										}
										for k, v := range caijimzd {
											if isUrl(shuju[k]) {
												caijiurl["m"][v] = shuju[k]
											}
										}
									} else {
										neirong += "采集电脑版和移动版网址出错！<br>"
									}
								}
								if len(caijiurl["pc"]) > 0 || len(caijiurl["m"]) > 0 {
									caijistart(caijiurl, dir, conn) //开始采集模板
									neirong += "模板采集完成！"
								}
							} else {
								neirong += "采集版本出错！<br>"
							}
						} else {
							neirong += "<p>采集版本(1:只采集电脑版/2:采集电脑版和移动版)<span style='color:#E53333;'>*</span>: <input type=text name='caiji' size='3' value=''>"
							neirong += "<br>---"
							neirong += "<br>电脑版首页网址<span style='color:#E53333;'>*</span>:<input type=text name='caijipc1' size='37' value=''>"
							neirong += "<br>电脑版栏目网址(单页)<span style='color:#E53333;'>*</span>:<input type=text name='caijipc2' size='31' value=''>"
							neirong += "<br>电脑版栏目网址(图片):<input type=text name='caijipc3' size='32' value=''>"
							neirong += "<br>电脑版栏目网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijipc4' size='31' value=''>"
							neirong += "<br>电脑版内页网址(图片):<input type=text name='caijipc5' size='32' value=''>"
							neirong += "<br>电脑版内页网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijipc6' size='31' value=''>"
							neirong += "<br>电脑版搜索网址:<input type=text name='caijipc7' size='38' value=''>"
							neirong += "<br>---"
							neirong += "<br>移动版首页网址<span style='color:#E53333;'>*</span>:<input type=text name='caijim1' size='37' value=''>"
							neirong += "<br>移动版栏目网址(单页)<span style='color:#E53333;'>*</span>:<input type=text name='caijim2' size='31' value=''>"
							neirong += "<br>移动版栏目网址(图片):<input type=text name='caijim3' size='32' value=''>"
							neirong += "<br>移动版栏目网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijim4' size='31' value=''>"
							neirong += "<br>移动版内页网址(图片):<input type=text name='caijim5' size='32' value=''>"
							neirong += "<br>移动版内页网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijim6' size='31' value=''>"
							neirong += "<br>移动版搜索网址:<input type=text name='caijim7' size='38' value=''>"
							neirong += "<br>---</p>"
							cid++
							neirong += fmt.Sprintf("<input type='button' value='开始采集' onclick=cmd2(%d) required>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "采集"}
							neirong += "<p><br>首页模板---index.htm<br>"
							neirong += "单页模板---channel_index.htm<br>"
							neirong += "栏目模板(图片)---channel_img.htm<br>"
							neirong += "栏目模板(文章)---channel_list.htm<br>"
							neirong += "内页模板(图片)---article_img.htm<br>"
							neirong += "内页模板(文章)---article_article.htm<br>"
							neirong += "搜索模板---search.htm<br></p>"
						}
					} else if cmd2 == "可疑文件扫描" {
					}
				} else {
					neirong += "<div id='infos'></div>"
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='网站模板管理' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "网站模板管理"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='网站模板采集' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "网站模板采集"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='可疑文件扫描' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "可疑文件扫描"}
				}
			case "留言管理":
				lsweb := web.R(wid)
				if cmd2 != "" {
					if cmd2 == "删除" {
						postid := cmds["postid"]
						if postid != "" {
							postid, _ := strconv.Atoi(postid)
							var sj2 []map[string]string
							json.Unmarshal([]byte(lsweb["post"]), &sj2)
							if postid < len(sj2) {
								sj2 = append(sj2[:postid], sj2[postid+1:]...)
							}
							b2, _ := json.Marshal(sj2)
							lsweb["post"] = string(b2)
							web.W(wid, lsweb) //更新
							neirong += "删除成功<br>"
						}
					} else if cmd2 == "清空所有留言" {
						lsweb["post"] = ""
						web.W(wid, lsweb) //更新
						neirong += "清空成功<br>"
					} else if cmd2 == "留言代码" {
						code := `<form action="/p/" method="post">
<label for="name">您的称呼:</label> <input type="text" name="name" required="" /> <br />
<label for="name">联系电话:</label> <input type="text" name="tel" required="" /> <br />
<label for="name">您的需求:</label> <textarea name="neirong" required=""></textarea> <br />
<input type="submit" value="提交" /> 
</form>`
						neirong += `<p>留言代码：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button> <button onclick="fuzhidaima()">复制代码</button><br></p><p><a id="mubanneirong2" style="display:none;">复制成功!</a></p>`
						neirong += "<p><textarea id='mubanneirong' name='mubanneirong' style='font-family: monospace; white-space: pre;resize: none;background-color:#1C1C1C;color: #8B814C;width:90%;overflow:auto;word-break:break-all;' cols='60' rows='40'>" + html.EscapeString(code) + "</textarea><br></p>"
					}
					cid++
					neirong += fmt.Sprintf("<a onclick=cmd(%d)>返回上一级</a><br>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "yema": yema}
				} else {
					cid++
					neirong += fmt.Sprintf("<p><a onclick=cmd(%d)>[留言代码]</a></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "留言代码"}
					//获取留言
					var sj []map[string]string
					json.Unmarshal([]byte(lsweb["post"]), &sj)
					zsl := len(sj)
					if zsl > 0 {
						var lsyema int
						if yema != "" {
							lsyema, _ = strconv.Atoi(yema)
						} else {
							lsyema = 1
						}
						if lsyema < 1 {
							lsyema = 1
						}
						ksid := (lsyema - 1) * 10
						jsid := ksid + 10
						if jsid >= zsl {
							jsid = zsl
						}
						if ksid < zsl {
							for _, v := range sj[ksid:jsid] {
								ksid++
								neirong += strconv.Itoa(ksid) + "."
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d)>删除</a><br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除", "postid": strconv.Itoa(ksid - 1), "yema": strconv.Itoa(lsyema)}
								for _, v2 := range postzd {
									neirong += v2 + "：" + v[v2] + "<br>"
								}
								neirong += "<br>"
							}
						}
						//创建页码
						ymif := ""
						if lsyema > 1 {
							cid++
							ymif += fmt.Sprintf("<a onclick=cmd(%d)>上页</a> ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "yema": strconv.Itoa(lsyema - 1)}

						}
						if jsid < zsl {
							cid++
							ymif += fmt.Sprintf("<a onclick=cmd(%d)>下.页</a> ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "yema": strconv.Itoa(lsyema + 1)}
						}
						if ymif != "" {
							neirong += "<br>" + ymif + "<br>"
						}

						cid++
						neirong += fmt.Sprintf("<br><a onclick=cmd(%d)>[清空所有留言]</a><br>", cid)
						dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "清空所有留言"}

					} else {
						neirong += "<p>暂无留言</p>"
					}
				}
			}
		}
		if neirong != "" {
			hfmsg["main"] = neirong
		}
		send(conn, hfmsg)
	}
}
