package main

import (
	"bytes"
	"compress/gzip"
	"encoding/json"
	"log"

	"github.com/gorilla/websocket"
)

// 回复给当前连接
func send(conn *Conn, hfmsg map[string]string) {
	hfmsgBytes, err := json.Marshal(hfmsg) // 将修改后的数据转换为JSON字符串
	if err != nil {
		log.Println("回复给当前连接时序列化消息失败:", err)
		return
	}
	len := len(hfmsgBytes)
	if len > 0 {
		if len > 100 {
			var buf bytes.Buffer
			gz := gzip.NewWriter(&buf) //开启压缩
			defer gz.Close()           // 确保压缩流关闭
			if _, err := gz.Write(hfmsgBytes); err != nil {
				log.Println("回复给当前连接压缩写入失败:", err)
				return
			}
			// 确保所有数据都被写入缓冲区
			if err := gz.Flush(); err != nil {
				log.Println("回复给当前连接压缩刷新失败:", err)
				return
			}
			//关闭压缩
			if err := gz.Close(); err != nil {
				log.Println("回复给当前连接压缩关闭失败:", err)
				return
			}
			hfmsgBytes = buf.Bytes()
		}
		if err := conn.WriteMessage(websocket.BinaryMessage, hfmsgBytes); err != nil {
			log.Println("回复给当前连接发送消息失败:", err)
			return
		}
	}
}

// 向管理同一个网站的用户推送数据
func send2(hfmsg map[string]interface{}, wid string) {
	hfmsgBytes, _ := json.Marshal(hfmsg) // 将修改后的数据转换为JSON字符串
	//历遍user
	for _, v := range user.R0() {
		if v.Wid == wid {
			if err := v.WriteMessage(websocket.BinaryMessage, hfmsgBytes); err != nil {
				log.Println("给指定连接用户发送消息时发送失败:", err)
			}
		}
	}
}

// 给指定连接用户发送消息

// 向所有连接用户发送消息
